<?
/*
Отключение кэширования WSDL
Список настроек SOAP-WSDL https://www.php.net/manual/ru/soap.configuration.php
*/
ini_set('soap.wsdl_cache_enabled', 0);

//Путь к WSDL файлу
$wsdl_file = 'http://test-site.ru/my_calculator/scheme.wsdl';

//Настройки SOAP
$soap_settings = array(
	'soap_version' => SOAP_1_1,
	'encoding' => 'utf-8',
	'trace' => true, //включение отслеживания конвертов (будут доступны методы __getLastRequest и __getLastResponse)
);

//Клиент
$soap_client = new SoapClient($wsdl_file, $soap_settings);

try
{
	$params = array(
 		'a' => 100,
 		'b' => 5,
 		'action' => '/',
 	);
 	$r = $soap_client->__soapCall('math_action', array($params));

 	echo '<pre>'.print_r($r, true).'</pre>';

	//Вывод последнего запроса
	echo '<b>Содержимое запроса:</b><br><pre>'.trim(htmlspecialchars($soap_client->__getLastRequest())).'</pre><br>';

	//Вывод последнего ответа
	echo '<b>Содержимое ответа:</b><br><pre>'.trim(htmlspecialchars($soap_client->__getLastResponse())).'</pre>';
}
catch(SoapFault $soap_error)
{
	echo '<b>Ошибка:</b> '.$soap_error->getMessage();
}

?>