<?
/**
* Отключение кэширования WSDL
* Список настроек SOAP-WSDL https://www.php.net/manual/ru/soap.configuration.php
*/
ini_set('soap.wsdl_cache_enabled', 0);

/**
* Класс обрабатывает запросы из SOAP-сервиса "Мой калькулятор"
*/
class my_calculator_class
{
	/**
	* Операция "Математическое действие". Выполняет математические действия
	* (сложение, вычитание, умножение и деление над двумя числами)
	*
	* @param stdClass $in_obj - объект с параметрами запроса
	* @return stdClass
	*/
	public function math_action($in_obj)
	{
		$r = new stdClass();

		$a = (float)$in_obj->a;
		$b = (float)$in_obj->b;
		$action = (string)$in_obj->action;

		switch($action)
		{
			case '+':
			{
            	$r->value = $a + $b;
            	break;
			}
			case '-':
			{
            	$r->value = $a - $b;
            	break;
			}
			case '*':
			{
            	$r->value = $a * $b;
            	break;
			}
			case '/':
			{
             	if($b==0) $r->message_error = 'Делить на ноль нелья';
             	else $r->value = $a / $b;
             	break;
			}
			default:
			{
             	$r->message_error = 'В параметре `action` пропущено или указано недопустимое математическое действие';
             	break;
			}
		}

		return $r;
	}

 	/**
 	* Возвращает приближённое значение числа Пи
	*
	* @param stdClass $in_obj - объект с параметрами запроса
	* @return stdClass
 	*/
	public function get_pi($arg)
	{
		$r = new stdClass();
		$r->value = 3.14;

		return $r;
	}
}

//Путь к WSDL файлу
$wsdl_file = $_SERVER['DOCUMENT_ROOT'].'/my_calculator/scheme.wsdl';

//Создаём объект SOAP-сервера
$soap_server = new SoapServer($wsdl_file, array(
	'soap_version' => SOAP_1_1,	//Версия протокола SOAP
	'encoding' => 'utf-8', 		//Кодировка, к которой должно приводиться содержимое запросов
));

//Устанавливаем на сервере класс, который будет обрабатывать запросы (операции из раздела wsdl:operation в WSDL файле)
$soap_server->setClass('my_calculator_class');

//Запуск обработки запросов
$soap_server->handle();

?>